local update_voice = update_voice or function()
	VoiceOptions:UpdateVoices()
end

local update_voice_AI = update_voice_AI or function()
	VoiceOptions:UpdateVoicesAI()
end

if RequiredScript == 'lib/managers/hud/hudblackscreen' then
	local HUDBlack_old = HUDBlack_old or HUDBlackScreen._animate_fade_out

	function HUDBlackScreen:_animate_fade_out(mid_text)
		HUDBlack_old(self, mid_text)
		DelayedCalls:Add("update_voices", 0.20, update_voice)
		DelayedCalls:Add("update_voices_AI", 0.20, update_voice_AI)
	end
end

Hooks:Add("NetworkReceivedData", "NetworkReceivedData_HVC_SetVoice", function(sender, id, data)

	if id == "HVC_SetVoice" then
	
		local unit = managers.player:player_unit( sender )
		unit:sound():set_voice( "rb" .. data )
	
	end
	
end )