_G.VoiceOptions = _G.VoiceOptions or {}
VoiceOptions._path = ModPath
VoiceOptions._opts_path = SavePath .. "voice_opts.txt"
VoiceOptions._opts = {}

local Net = _G.LuaNetworking

VoiceOptions._voices = {
	"4",
	"3",
	"1",
	"2",
	"6",
	"5",
	"7",
	"8",
	"9",
	"10",
	"11",
	"12",
	"13",
	"14",
	"15",
	"16",
	"17",
	"18",
	"19",
	"20",
	"21",
	"22",
}

function VoiceOptions:UpdateVoices()
	if VoiceOptions._opts.enabled then
		if Utils:IsInHeist() and not Utils:IsInCustody() then
			local character = managers.criminals:local_character_name()
			if character == "russian" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc1] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc1] )
				end
			elseif character == "german" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc2] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc2] )
				end
			elseif character == "spanish" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc3] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc3] )
				end
			elseif character == "american" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc4] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc4] )
				end
			elseif character == "jowi" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc5] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc5] )
				end
			elseif character == "old_hoxton" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc6] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc6] )
				end
			elseif character == "female_1" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc7] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc7] )
				end
			elseif character == "dragan" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc8] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc8] )
				end
			elseif character == "jacket" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc9] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc9] )
				end
			elseif character == "bonnie" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc10] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc10] )
				end
			elseif character == "sokol" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc11] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc11] )
				end
			elseif character == "dragon" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc12] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc12] )
				end
			elseif character == "bodhi" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc13] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc13] )
				end
			elseif character == "jimmy" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc14] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc14] )
				end
            elseif character == "sidney" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc15] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc15] )
				end
			elseif character == "wild" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc16] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc16] )
				end
			elseif character == "terry" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc17] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc17] )
				end
			elseif character == "max" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc18] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc18] )
				end
			elseif character == "joy" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc19] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc19] )
				end
			elseif character == "ecp_male" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc20] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc20] )
				end
			elseif character == "ecp_female" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc21] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc21] )
				end
			elseif character == "myh" then
				managers.player:player_unit():sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc22] )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", VoiceOptions._voices[VoiceOptions._opts.voc22] )
				end
			end
		end
	elseif not VoiceOptions._opts.enabled then
		if Utils:IsInHeist() and not Utils:IsInCustody() then
			local character = managers.criminals:local_character_name()
			if character == "russian" then
				managers.player:player_unit():sound():set_voice( "rb4" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "4" )
				end
			elseif character == "german" then
				managers.player:player_unit():sound():set_voice( "rb3" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "3" )
				end
			elseif character == "spanish" then
				managers.player:player_unit():sound():set_voice( "rb1" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "1" )
				end
			elseif character == "american" then
				managers.player:player_unit():sound():set_voice( "rb2" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "2" )
				end
			elseif character == "jowi" then
				managers.player:player_unit():sound():set_voice( "rb6" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "6" )
				end
			elseif character == "old_hoxton" then
				managers.player:player_unit():sound():set_voice( "rb5" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "5" )
				end
			elseif character == "female_1" then
				managers.player:player_unit():sound():set_voice( "rb7" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "7" )
				end
			elseif character == "dragan" then
				managers.player:player_unit():sound():set_voice( "rb8" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "8" )
				end
			elseif character == "jacket" then
				managers.player:player_unit():sound():set_voice( "rb9" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "9" )
				end
			elseif character == "bonnie" then
				managers.player:player_unit():sound():set_voice( "rb10" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "10" )
				end
			elseif character == "sokol" then
				managers.player:player_unit():sound():set_voice( "rb11" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "11" )
				end
			elseif character == "dragon" then
				managers.player:player_unit():sound():set_voice( "rb12" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "12" )
				end
			elseif character == "bodhi" then
				managers.player:player_unit():sound():set_voice( "rb13" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "13" )
				end
			elseif character == "jimmy" then
				managers.player:player_unit():sound():set_voice( "rb14" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "14" )
				end
			elseif character == "sidney" then
				managers.player:player_unit():sound():set_voice( "rb15" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "15" )
				end
			elseif character == "wild" then
				managers.player:player_unit():sound():set_voice( "rb16" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "17" )
				end
			elseif character == "terry" then
				managers.player:player_unit():sound():set_voice( "rb17" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "17" )
				end
			elseif character == "max" then
				managers.player:player_unit():sound():set_voice( "rb18" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "18" )
				end
			elseif character == "joy" then
				managers.player:player_unit():sound():set_voice( "rb19" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "19" )
				end
			elseif character == "ecp_male" then
				managers.player:player_unit():sound():set_voice( "rb20" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "20" )
				end
			elseif character == "ecp_female" then
				managers.player:player_unit():sound():set_voice( "rb21" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "21" )
				end
			elseif character == "myh" then
				managers.player:player_unit():sound():set_voice( "rb22" )
				if Net:IsMultiplayer() then
					Net:SendToPeers( "HVC_SetVoice", "22" )
				end					
			end
		end
	end
end

function VoiceOptions:UpdateVoicesAI()
	if VoiceOptions._opts.ai_enabled then
		if Utils:IsInHeist() and not Utils:IsInCustody() then
			local criminalsAI = managers.groupai:state():all_AI_criminals()
			for _, u_data in pairs(criminalsAI) do
				local character = managers.criminals:character_name_by_unit(u_data.unit)
				if character == "russian" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc1] )
				elseif character == "german" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc2] )
				elseif character == "spanish" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc3] )
				elseif character == "american" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc4] )
				elseif character == "jowi" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc5] )
				elseif character == "old_hoxton" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc6] )
				elseif character == "female_1" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc7] )
				elseif character == "dragan" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc8] )
				elseif character == "jacket" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc9] )
				elseif character == "bonnie" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc10] )
				elseif character == "sokol" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc11] )
				elseif character == "dragon" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc12] )
				elseif character == "bodhi" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc13] )
				elseif character == "jimmy" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc14] )
				elseif character == "sidney" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc15] )
				elseif character == "wild" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc16] )
				elseif character == "terry" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc17] )
				elseif character == "max" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc18] )
				elseif character == "joy" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc19] )
				elseif character == "ecp_male" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc20] )
				elseif character == "ecp_female" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc21] )
				elseif character == "myh" then
					u_data.unit:sound():set_voice( "rb" .. VoiceOptions._voices[VoiceOptions._opts.voc22] )
				end
				log( "[HVC] " .. character .. " enabled" )
			end
		end
	elseif not VoiceOptions._opts.ai_enabled then
		if Utils:IsInHeist() and not Utils:IsInCustody() then
			local criminalsAI = managers.groupai:state():all_AI_criminals()
			for _, u_data in pairs(criminalsAI) do
				local character = managers.criminals:character_name_by_unit(u_data.unit)
				if character == "russian" then
					u_data.unit:sound():set_voice( "rb4" )
				elseif character == "german" then
					u_data.unit:sound():set_voice( "rb3" )
				elseif character == "spanish" then
					u_data.unit:sound():set_voice( "rb1" )
				elseif character == "american" then
					u_data.unit:sound():set_voice( "rb2" )
				elseif character == "jowi" then
					u_data.unit:sound():set_voice( "rb6" )
				elseif character == "old_hoxton" then
					u_data.unit:sound():set_voice( "rb5" )
				elseif character == "female_1" then
					u_data.unit:sound():set_voice( "rb7" )
				elseif character == "dragan" then
					u_data.unit:sound():set_voice( "rb8" )
				elseif character == "jacket" then
					u_data.unit:sound():set_voice( "rb9" )
				elseif character == "bonnie" then
					u_data.unit:sound():set_voice( "rb10" )
				elseif character == "sokol" then
					u_data.unit:sound():set_voice( "rb11" )
				elseif character == "dragon" then
					u_data.unit:sound():set_voice( "rb12" )
				elseif character == "bodhi" then
					u_data.unit:sound():set_voice( "rb13" )
				elseif character == "jimmy" then
					u_data.unit:sound():set_voice( "rb14" )
				elseif character == "sidney" then
					u_data.unit:sound():set_voice( "rb15" )
				elseif character == "wild" then
					u_data.unit:sound():set_voice( "rb16" )
				elseif character == "terry" then
					u_data.unit:sound():set_voice( "rb17" )
				elseif character == "max" then
					u_data.unit:sound():set_voice( "rb18" )
				elseif character == "joy" then
					u_data.unit:sound():set_voice( "rb19" )
				elseif character == "ecp_male" then
					u_data.unit:sound():set_voice( "rb20" )
				elseif character == "ecp_female" then
					u_data.unit:sound():set_voice( "rb21" )
				elseif character == "myh" then
					u_data.unit:sound():set_voice( "rb22" )					
				end
				log( "[HVC] " .. character .. " diabled" )
			end
		end
	end
end

function VoiceOptions:Save()
	local data = io.open( self._opts_path, "w+" )
	if data then
		data:write( json.encode( self._opts ) )
		data:close()
	end
end

function VoiceOptions:Load()
	local data = io.open( self._opts_path, "r" )
	if data then
		self._opts = json.decode( data:read("*all") )
		data:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "LMPI_VoiceOptions", function( loc )
	loc:load_localization_file( VoiceOptions._path .. "loc/en.txt")
end)

Hooks:Add( "MenuManagerInitialize", "MMI_VoiceOption", function( menu_manager )

	MenuCallbackHandler.clbk_voc_tog_enable = function(self, item)
		VoiceOptions._opts.enabled = (item:value() == "on" and true or false)
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("HVC Enabled: " .. item:value())
	end
	
	MenuCallbackHandler.clbk_voc_tog_ai_enable = function(self, item)
		VoiceOptions._opts.ai_enabled = (item:value() == "on" and true or false)
		VoiceOptions:Save()
		VoiceOptions:UpdateVoicesAI()
		--log("HVC AI Enabled: " .. item:value())
	end
	
	MenuCallbackHandler.clbk_voc_1 = function(self, item)
		VoiceOptions._opts.voc1 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Dallas Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_2 = function(self, item)
		VoiceOptions._opts.voc2 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Wolf Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_3 = function(self, item)
		VoiceOptions._opts.voc3 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Chains Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_4 = function(self, item)
		VoiceOptions._opts.voc4 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Houston Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_5 = function(self, item)
		VoiceOptions._opts.voc5 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("John Wick Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_6 = function(self, item)
		VoiceOptions._opts.voc6 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Hoxton Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_7 = function(self, item)
		VoiceOptions._opts.voc7 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Clover Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_8 = function(self, item)
		VoiceOptions._opts.voc8 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Dragan Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_9 = function(self, item)
		VoiceOptions._opts.voc9 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Jacket Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_10 = function(self, item)
		VoiceOptions._opts.voc10 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Bonnie Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_11 = function(self, item)
		VoiceOptions._opts.voc11 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Sokol Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_12 = function(self, item)
		VoiceOptions._opts.voc12 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Jiro Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_13 = function(self, item)
		VoiceOptions._opts.voc13 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Bodhi Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_14 = function(self, item)
		VoiceOptions._opts.voc14 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Jimmy Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_15 = function(self, item)
		VoiceOptions._opts.voc15 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Sidney Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_16 = function(self, item)
		VoiceOptions._opts.voc16 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Rust Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_17 = function(self, item)
		VoiceOptions._opts.voc17 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Scarface Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_18 = function(self, item)
		VoiceOptions._opts.voc18 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Sangres Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_19 = function(self, item)
		VoiceOptions._opts.voc19 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Duke Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_20 = function(self, item)
		VoiceOptions._opts.voc20 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Ethan Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_21 = function(self, item)
		VoiceOptions._opts.voc21 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("Hila Voice set to: " .. item:value())
	end
	MenuCallbackHandler.clbk_voc_22 = function(self, item)
		VoiceOptions._opts.voc22 = item:value()
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		--log("myh Voice set to: " .. item:value())
	end
	
	MenuCallbackHandler.clbk_voc_default = function(self, item)
		VoiceOptions._opts.voc1 = 1
		VoiceOptions._opts.voc2 = 2
		VoiceOptions._opts.voc3 = 3
		VoiceOptions._opts.voc4 = 4
		VoiceOptions._opts.voc5 = 5
		VoiceOptions._opts.voc6 = 6
		VoiceOptions._opts.voc7 = 7
		VoiceOptions._opts.voc8 = 8
		VoiceOptions._opts.voc9 = 9
		VoiceOptions._opts.voc10 = 10
		VoiceOptions._opts.voc11 = 11
		VoiceOptions._opts.voc12 = 12
		VoiceOptions._opts.voc13 = 13
		VoiceOptions._opts.voc14 = 14 
		VoiceOptions._opts.voc15 = 15
		VoiceOptions._opts.voc16 = 16
		VoiceOptions._opts.voc17 = 17
		VoiceOptions._opts.voc18 = 18
		VoiceOptions._opts.voc19 = 19
		VoiceOptions._opts.voc20 = 20
		VoiceOptions._opts.voc21 = 21
		VoiceOptions._opts.voc22 = 22
		
		VoiceOptions:Save()
		VoiceOptions:UpdateVoices()
		VoiceOptions:UpdateVoicesAI()
		
		VoiceOptions:Load()
		MenuHelper:LoadFromJsonFile( VoiceOptions._path .. "options/voice_options.txt", VoiceOptions, VoiceOptions._opts )
		--log("All values have been reset.")
	end
		
	VoiceOptions:Load()
	
	MenuHelper:LoadFromJsonFile( VoiceOptions._path .. "options/voice_options.txt", VoiceOptions, VoiceOptions._opts )

end )